using ldap_cesi.DTOs;
using ldap_cesi.DTOs.Inputs.Salarie;
using ldap_cesi.DTOs.Inputs.Service;
using ldap_cesi.DTOs.Outputs.Salarie;
using ldap_cesi.Entities;
using ldap_cesi.Models;

namespace ldap_cesi.Services.Interfaces;

public interface ISalarieService : IServiceBase<Salarie, SalarieDto, SalarieCreateDto, SalarieUpdateDto>
{
    Task<IResponseDataModel<List<Salarie>>> GetAllWithoutIService();
    Task<IResponseDataModel<List<SalarieListDto>>> GetSalariesBySite(int siteId);
    Task<IResponseDataModel<List<SalarieListDto>>> GetSalariesByService(int serviceId);
    Task<IResponseDataModel<SalarieDto>> GetCompletById(int id);
}