using AutoMapper;
using ldap_cesi.DTOs.Inputs.Service;
using ldap_cesi.Entities;
using ldap_cesi.Models;
using ldap_cesi.Repository.Services;
using ldap_cesi.Services.Interfaces;
using ldap_cesi.Validator.Service;
using ldap_cesi.DTOs;
using ldap_cesi.DTOs.Inputs.Service;

namespace ldap_cesi.Services;

public class ServiceService : ServiceBase<Service, ServiceDto, ServiceCreateDto, ServiceUpdateDto>, IServiceService
{

    public ServiceService(IRepositoryService repositoryService, IMapper mapper, ILogger<ServiceService> logger, ServiceCreateValidator serviceCreateValidator, ServiceUpdateValidator serviceUpdateValidator) 
        : base(repositoryService, mapper, logger, serviceCreateValidator, serviceUpdateValidator)
    {
    }


    // public async Task<IResponseDataModel<List<Service>>> GetAll()
    // {
    //     var services = await _repositoryService.GetAllAsync();
    //     return new ResponseDataModel<List<Service>>
    //     {
    //         Success = true,
    //         Data = services,
    //         StatusCode = 200,
    //     };
    // }    
    
    // public async Task<IResponseDataModel<Service>> GetById(int id)
    // {
    //     var service = await _repositoryService.GetByIdAsync(id);
    //     return new ResponseDataModel<Service>
    //     {
    //         Success = true,
    //         Data = service,
    //         StatusCode = 200,
    //     };
    // }

    // public async Task<IResponseDataModel<string>> CreateService(ServiceCreateDto serviceCreateDto)
    // {
    //     var validation = new ServiceCreateValidator();
    //     var result = validation.Validate(serviceCreateDto);
    //     if (!result.IsValid)
    //     {
    //         return new ResponseDataModel<string>
    //         {
    //             StatusCode = 400,
    //             Success = false,
    //             Message = "Données du service invalides: " + string.Join(", ", result.Errors)
    //         };
    //     }
    //     var service = _mapper.Map<Service>(serviceCreateDto);
    //     var response = await _repositoryService.AddAsync(service);
    //     return new ResponseDataModel<string>
    //     {
    //         StatusCode = 201,
    //         Success = true,
    //         Data = response.Id.ToString(),
    //     };
    // }
    
    // public async Task<IResponseDataModel<Service>> UpdateService(ServiceUpdateDto serviceUpdateDto)
    // {
    //     var validation = new ServiceUpdateValidator();
    //     var result = validation.Validate(serviceUpdateDto);
    //     if (!result.IsValid)
    //     {
    //         return new ResponseDataModel<Service>
    //         {
    //             StatusCode = 400,
    //             Success = false,
    //             Message = "Données du service invalides: " + string.Join(", ", result.Errors)
    //         };
    //     }
    //     var serviceFind = await _repositoryService.GetByIdAsync(serviceUpdateDto.Id);
    //     if (serviceFind is null)
    //     {
    //         return new ResponseDataModel<Service>
    //         {
    //             Success = false,
    //             Message = "Service introuvable.",
    //             StatusCode = 404
    //         };
    //     }
        
    //     var service =    _mapper.Map(serviceUpdateDto, serviceFind);
    //     var response = await _repositoryService.UpdateAsync(service);
    //     if (!response)
    //     {
    //         return new ResponseDataModel<Service>
    //         {
    //             StatusCode = 500,
    //             Success = false,
    //             Message = "Erreur lors de la mise à jour du service : " + string.Join(", ", result.Errors)
    //         };
    //     }
    //     return new ResponseDataModel<Service>
    //     {
    //         StatusCode = 200,
    //         Success = true,
    //         Data = service,
    //     };
    // }    
    
    // public async Task<IResponseDataModel<string>> DeleteService(int idService)
    // {
    //     if (idService == null)
    //     {
    //         return new ResponseDataModel<string>
    //         {
    //             StatusCode = 400,
    //             Success = false,
    //             Message = "Id manquant"
    //         };
    //     }

    //     var service = await _repositoryService.GetByIdAsync(idService);
    //     if (service == null)
    //     {
    //         return new ResponseDataModel<string>
    //         {
    //             Success = false,
    //             Message = "Service introuvable.",
    //             StatusCode = 404
    //         };
    //     }
    //     var response = await _repositoryService.DeleteAsync(service);
    //     if (!response)
    //     {
    //         return new ResponseDataModel<string>
    //         {
    //             StatusCode = 500,
    //             Success = false,
    //             Message = "Erreur durant la suppression du service"
    //         };
    //     }
    //     return new ResponseDataModel<string>
    //         {
    //             StatusCode = 200,
    //             Success = true,
    //             Data = service.Id.ToString(),
    //         };
    // }
}